package fr.ul.projet.modele;

import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;

import fr.ul.projet.outils.FabriqueIdentifiant;
public class Piece {

    private int id;
    String nom;
    String photoNord, photoSud, photoEst, photoOuest;

    HashMap<Integer, Acces> acces = new HashMap<>();


    public Piece(String nom, String photoNord, String photoSud, String photoEst, String photoOuest){
        this.id = FabriqueIdentifiant.getInstance().getIdentifiantPiece();
        this.photoNord = photoNord;
        this.photoSud = photoSud;
        this.photoEst = photoEst;
        this.photoOuest = photoOuest;
        this.nom = nom;
    }
    public int getId(){
        return this.id;
    }

    public String getNom() {
        return this.nom;
    }

    public void setNom(String nom){
        this.nom = nom;
    }

    public String getPhotoNord() {
        return this.photoNord;
    }

    public void setPhotoNord(String photoNord){
        this.photoNord = photoNord;
    }

    public String getPhotoEst() {
        return this.photoEst;
    }

    public void setPhotoEst(String photoEst){
        this.photoEst = photoEst;
    }

    public String getPhotoSud() {
        return this.photoSud;
    }
    public void setPhotoSud(String photoSud){
        this.photoSud = photoSud;
    }
    public String getPhotoOuest(){
        return this.photoOuest;
    }
    public void setPhotoOuest(String photoOuest){
        this.photoOuest = photoOuest;
    }


    public HashMap<Integer, Acces> getAcces(){
        return this.acces;
    }

    public void ajouterAcces(Piece destination, int x1, int y1, int x2, int y2){
        Acces acc = new Acces(destination, x1, y1, x2, y2);
        this.getAcces().put(acc.getId(), acc);
    }

    public void supprimerAcces(String idAcces){
        this.getAcces().remove(idAcces);
    }

    public Map toJson(){
        Map page = new LinkedHashMap();
        page.put("id", this.getId());
        page.put("nom", this.getNom());
        page.put("cheminPhotoNord", this.getPhotoNord());
        page.put("cheminPhotoSud", this.getPhotoSud());
        page.put("cheminPhotoEst", this.getPhotoEst());
        page.put("cheminPhotoOuest", this.getPhotoOuest());
        return page;
    }


}
